// CopyRight Philipos Sakellaropoulos 2001
// UrlComponents.cpp : Implementation of CUrlComponents
#include "stdafx.h"
#include "MyInetUtils.h"
#include "UrlComponents.h"

/////////////////////////////////////////////////////////////////////////////
// CUrlComponents


STDMETHODIMP CUrlComponents::get_Scheme(BSTR *pVal)
{
	*pVal = strScheme.Copy(); 
	return S_OK;
}

STDMETHODIMP CUrlComponents::put_Scheme(BSTR newVal)
{
	strScheme = newVal;
	return S_OK;
}

STDMETHODIMP CUrlComponents::get_HostName(BSTR *pVal)
{
	*pVal = strHostName.Copy(); 
	return S_OK;
}

STDMETHODIMP CUrlComponents::put_HostName(BSTR newVal)
{
	strHostName = newVal;
	return S_OK;
}

STDMETHODIMP CUrlComponents::get_Port(long *pVal)
{
	*pVal = Port; 
	return S_OK;
}

STDMETHODIMP CUrlComponents::put_Port(long newVal)
{
	Port = newVal;
	return S_OK;
}

STDMETHODIMP CUrlComponents::get_UserName(BSTR *pVal)
{
	*pVal = strUserName.Copy(); 
	return S_OK;
}

STDMETHODIMP CUrlComponents::put_UserName(BSTR newVal)
{
	strUserName = newVal;
	return S_OK;
}

STDMETHODIMP CUrlComponents::get_Password(BSTR *pVal)
{
	*pVal = strPassword.Copy(); 
	return S_OK;
}

STDMETHODIMP CUrlComponents::put_Password(BSTR newVal)
{
	strPassword = newVal;
	return S_OK;
}

STDMETHODIMP CUrlComponents::get_UrlPath(BSTR *pVal)
{
	*pVal = strUrlPath.Copy(); 
	return S_OK;
}

STDMETHODIMP CUrlComponents::put_UrlPath(BSTR newVal)
{
	strUrlPath = newVal;
	return S_OK;
}

STDMETHODIMP CUrlComponents::get_ExtraInfo(BSTR *pVal)
{
	*pVal = strExtraInfo.Copy(); 
	return S_OK;
}

STDMETHODIMP CUrlComponents::put_ExtraInfo(BSTR newVal)
{
	strExtraInfo = newVal;
	return S_OK;
}

STDMETHODIMP CUrlComponents::get_FullURL(BSTR *pVal)
{
	*pVal = strFullURL.Copy();
	return S_OK;
}

STDMETHODIMP CUrlComponents::put_FullURL(BSTR newVal)
{
	strFullURL = newVal;
	return S_OK;
}
