// CopyRight Philipos Sakellaropoulos 2001
// UrlComponents.h : Declaration of the CUrlComponents

#ifndef __URLCOMPONENTS_H_
#define __URLCOMPONENTS_H_

#include "resource.h"       // main symbols

/////////////////////////////////////////////////////////////////////////////
// CUrlComponents
class ATL_NO_VTABLE CUrlComponents : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CUrlComponents, &CLSID_UrlComponents>,
	public IDispatchImpl<IUrlComponents, &IID_IUrlComponents, &LIBID_MYINETUTILSLib>
{
public:
	CUrlComponents()
	{
	}

DECLARE_REGISTRY_RESOURCEID(IDR_URLCOMPONENTS)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CUrlComponents)
	COM_INTERFACE_ENTRY(IUrlComponents)
	COM_INTERFACE_ENTRY(IDispatch)
END_COM_MAP()

public:
 CComBSTR strScheme,strHostName,strUserName,strPassword,strUrlPath,strExtraInfo,strFullURL;
 long Port;

// IUrlComponents
public:
	STDMETHOD(get_FullURL)(/*[out, retval]*/ BSTR *pVal);
	STDMETHOD(put_FullURL)(/*[in]*/ BSTR newVal);
	STDMETHOD(get_ExtraInfo)(/*[out, retval]*/ BSTR *pVal);
	STDMETHOD(put_ExtraInfo)(/*[in]*/ BSTR newVal);
	STDMETHOD(get_UrlPath)(/*[out, retval]*/ BSTR *pVal);
	STDMETHOD(put_UrlPath)(/*[in]*/ BSTR newVal);
	STDMETHOD(get_Password)(/*[out, retval]*/ BSTR *pVal);
	STDMETHOD(put_Password)(/*[in]*/ BSTR newVal);
	STDMETHOD(get_UserName)(/*[out, retval]*/ BSTR *pVal);
	STDMETHOD(put_UserName)(/*[in]*/ BSTR newVal);
	STDMETHOD(get_Port)(/*[out, retval]*/ long *pVal);
	STDMETHOD(put_Port)(/*[in]*/ long newVal);
	STDMETHOD(get_HostName)(/*[out, retval]*/ BSTR *pVal);
	STDMETHOD(put_HostName)(/*[in]*/ BSTR newVal);
	STDMETHOD(get_Scheme)(/*[out, retval]*/ BSTR *pVal);
	STDMETHOD(put_Scheme)(/*[in]*/ BSTR newVal);
};

#endif //__URLCOMPONENTS_H_
